package dev.peerat.parser.java.tree;

import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.state.RedirectStateTree;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class ClassBaseTree extends SyntaxTree<JavaElement> {
	
	private StateTree<JavaElement> modifierState;

	public ClassBaseTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		StateTree<JavaElement> modifier = registery.getNode(ModifierTree.class);

		StateTree<JavaElement> clazz_ = this.current;
		this.modifierState = clazz_.then(new RedirectStateTree<>(modifier, (global, local) -> global.set("modifier", local)));
	}
	
	public StateTree<JavaElement> getModifierNode(){
		return this.modifierState;
	}

}
