package dev.peerat.parser.visitor;

import java.util.ArrayList;
import java.util.List;

//only one pass in parameter or visit ?
public class VisitorBag{
	
	private List<Object> collect;
	private List<Object> list;
	
	public VisitorBag(){
		this.collect = new ArrayList<>();
		this.list = new ArrayList<>();
	}

	public void compute(Object element){
//		System.out.println("compute("+collect+", "+list+") "+element+" <- "+Thread.currentThread().getStackTrace()[2]);
		this.list.add(element);
	}
	
	public void merge(VisitorBag bag){
//		System.out.println("merge("+collect+", "+list+") <- "+Thread.currentThread().getStackTrace()[2]);
		this.collect.addAll(bag.collect);
//		System.out.println("merged("+collect+", "+list+") <- "+Thread.currentThread().getStackTrace()[2]);
	}
	
	public boolean isValidated(){
		return !this.list.isEmpty();
	}
	
	public List<Object> computeList(){
		return this.list;
	}
	
	VisitorBag collect(){
		this.collect.addAll(this.list);
//		System.out.println("collected("+collect+", "+list+") <- "+Thread.currentThread().getStackTrace()[2]);
		return this;
	}
	
	public <T> T toElement(){
		return (T) this.collect.get(0);
	}
	
	public <T> List<T> toList(){
		return (List<T>) this.collect;
	}
}